import pygame
from enum import Enum

# ---

WINDOW_TITLE = "BlockMania"
WINDOW_COLOR = pygame.Color('Brown')

# ---

ROW_COUNT = 20
COL_COUNT = 10

TILE_WIDTH  = 40
TILE_HEIGHT = 30

# ---

GAME_FIELD_BACKGROUND_COLOR = pygame.Color('Black')
GAME_FIELD_GRID_COLOR = pygame.Color('DarkSlateGray')

GAME_FIELD_WIDTH  = (COL_COUNT * TILE_WIDTH)
GAME_FIELD_HEIGHT = (ROW_COUNT * TILE_HEIGHT)

GAME_FIELD_LOCATION_X = 25
GAME_FIELD_LOCATION_Y = 30

GAME_FIELD_BORDER_COLOR = pygame.Color('Orange')
GAME_FIELD_BORDER_WIDTH = 2

# ---

PREVIEW_TILE_WIDTH  = 15
PREVIEW_TILE_HEIGHT = 15

PREVIEW_FIELD_WIDTH  = (PREVIEW_TILE_WIDTH  * 5)
PREVIEW_FIELD_HEIGHT = (PREVIEW_TILE_HEIGHT * 4)

PREVIEW_FIELD_LOCATION_X = (GAME_FIELD_LOCATION_X + GAME_FIELD_WIDTH + 50)
PREVIEW_FIELD_LOCATION_Y = GAME_FIELD_LOCATION_Y

# ---

SCORE_LOCATION_X = PREVIEW_FIELD_LOCATION_X - 20
SCORE_LOCATION_Y = (PREVIEW_FIELD_LOCATION_Y + PREVIEW_FIELD_HEIGHT + 20)

# ---

WINDOW_SIZE = (GAME_FIELD_WIDTH + PREVIEW_FIELD_WIDTH + 190, GAME_FIELD_HEIGHT + 60)

# ---

COL_MIN = 0
COL_MAX = (COL_COUNT - 1)

ROW_MIN = 0
ROW_MAX = (ROW_COUNT - 1)

# ---


class EnumUserInput(Enum):

    NONE         = 100
    ESCAPE       = 110

    ROTATE       = 120
    FLIP         = 130

    MOVE_LEFT    = 140
    MOVE_RIGHT   = 150

    MOVE_UP      = 160
    MOVE_DOWN    = 170

    TITLE_SCREEN = 180
    PLAY_SCREEN  = 190
    PREFS_SCREEN = 200
    HELP_SCREEN  = 210

    SELECT_BLOCK = 220

    F5 = 230
    F6 = 240
    F7 = 250
    F8 = 260


LEVEL_UP_THRESHOLD = 6  # Do level-up every time this number of rows have been cleared.

COLOR_TRANSITION_BLINDS = pygame.Color('Orange')
