from enum import Enum

import blockmania_data
from util.classes.class_Delay import Delay
from view import field


class EnumState(Enum):
    IDLE        = 10
    IN_PROGRESS = 20
    FINISHED    = 30


class EnumActionType(Enum):
    MARK   = 10
    REMOVE = 20


class gb:  # global data.

    state  = EnumState.IDLE
    action_type = EnumActionType.MARK

    delay = Delay(30)

    rows_to_mark = []

    row_index = 0
    col_index = 0


def start(rows, action):

    gb.rows_to_mark = rows

    gb.row_index = 0
    gb.col_index = 0

    gb.state  = EnumState.IN_PROGRESS
    gb.action_type = action


def handle_gametick():
    mark_tiles()


def mark_tiles():

    if gb.state != EnumState.FINISHED and gb.delay.has_expired():

        row = gb.rows_to_mark[gb.row_index]
        mark_or_remove_tile(row, gb.col_index)

        gb.col_index += 1
        if gb.col_index == blockmania_data.COL_COUNT:
            gb.col_index = 0
            gb.row_index += 1

        if gb.row_index == len(gb.rows_to_mark):
            gb.state = EnumState.FINISHED


def mark_or_remove_tile(row, col):

    match gb.action_type:
        case EnumActionType.MARK   : mark_tile(row, col)
        case EnumActionType.REMOVE : remove_tile(row, col)


def mark_tile(row, col):
    field.gb.grid[row][col] += 100


def remove_tile(row, col):
    field.remove_tile_by_coords(row, col)
