import pygame
from pygame.surface import Surface

import blockmania_data
import blockmania_display
from general_states.screen_02_play import block_speed
from general_states.screen_03_preferences import screen_preferences
from util import font_manager


class gb:  # global data.

    surface_hi_score: Surface
    surface_score: Surface
    surface_rows: Surface
    surface_level: Surface

    hi_score = 0
    score = 0

    rows = 0
    rows_temp = 0


def init():
    gb.surface_hi_score = font_manager.gb.font_03.render("HI-SCORE :", True, pygame.Color('yellow'))
    gb.surface_score    = font_manager.gb.font_03.render("SCORE :",    True, pygame.Color('yellow'))
    gb.surface_rows     = font_manager.gb.font_03.render("ROWS :",     True, pygame.Color('yellow'))
    gb.surface_level    = font_manager.gb.font_03.render("LEVEL :",    True, pygame.Color('yellow'))


def reset():
    gb.score = 0
    gb.rows  = 0
    gb.rows_temp = 0


def render():

    x = blockmania_data.SCORE_LOCATION_X
    y = blockmania_data.SCORE_LOCATION_Y

    blockmania_display.canvas.blit(gb.surface_hi_score, (x, y))
    y += 25
    surface = font_manager.gb.font_02.render(str(gb.hi_score).zfill(7), True, pygame.Color('white'))
    blockmania_display.canvas.blit(surface, (x, y))

    # 'zfill' stands for 'zero-fill', this function adds '0's padded to the left.

    y += 65
    blockmania_display.canvas.blit(gb.surface_score, (x, y))
    y += 25
    surface = font_manager.gb.font_02.render(str(gb.score).zfill(7), True, pygame.Color('white'))
    blockmania_display.canvas.blit(surface, (x, y))

    y += 40
    blockmania_display.canvas.blit(gb.surface_rows, (x, y))
    y += 25
    surface = font_manager.gb.font_02.render(str(gb.rows).zfill(3), True, pygame.Color('white'))
    blockmania_display.canvas.blit(surface, (x, y))

    y += 65
    blockmania_display.canvas.blit(gb.surface_level, (x, y))
    y += 25
    surface = font_manager.gb.font_02.render(str(block_speed.gb.level).zfill(2), True, pygame.Color('white'))
    blockmania_display.canvas.blit(surface, (x, y))


def add_rows(row_count):

    gb.rows += row_count
    update_score(row_count)

    gb.rows_temp += row_count
    level_up_if_appropriate()


def update_score(row_count):

    # The points for [cleared rows] are calculated as follows :
    # points = (40 * level) * 1 or 2.5 or 7.5 or 30

    factor = 1
    match row_count:
        case 2: factor = 2.5
        case 3: factor = 7.5
        case 4: factor = 30

    points = int(40 * block_speed.gb.level * factor)
    gb.score += points

    if gb.score > gb.hi_score:
        gb.hi_score = gb.score


def level_up_if_appropriate():

    if screen_preferences.gb.setting_do_level_up and gb.rows_temp >= blockmania_data.LEVEL_UP_THRESHOLD:

        block_speed.increase_level()
        gb.rows_temp -= blockmania_data.LEVEL_UP_THRESHOLD



