import pygame

from util import font_manager, tools
from util.classes.class_BlinkingText import BlinkingText
from util.classes.class_RepetitionChecker import RepetitionChecker

repetitionChecker = RepetitionChecker()


class gb:  # global data.

    blinking_text_01: BlinkingText = None
    blinking_text_02: BlinkingText = None
    blinking_text_03: BlinkingText = None
    blinking_text_04: BlinkingText = None

    text_01_x = 0
    text_01_y = 0


def init():
    text_01_surface = font_manager.gb.font_02.render("press", True, pygame.Color('white'))
    gb.text_01_x = tools.calculate_x_for_game_field_text(text_01_surface)
    gb.text_01_y = 180
    gb.blinking_text_01 = BlinkingText(text_01_surface, gb.text_01_x, gb.text_01_y)

    text_02_surface = font_manager.gb.font_02.render("'ESC'", True, pygame.Color('yellow'))
    text_02_x = tools.calculate_x_for_game_field_text(text_02_surface)
    text_02_y = gb.text_01_y + 45
    gb.blinking_text_02 = BlinkingText(text_02_surface, text_02_x, text_02_y)

    text_03_surface = font_manager.gb.font_02.render("to", True, pygame.Color('white'))
    text_03_x = tools.calculate_x_for_game_field_text(text_03_surface)
    text_03_y = text_02_y + 45
    gb.blinking_text_03 = BlinkingText(text_03_surface, text_03_x, text_03_y)

    text_04_surface = font_manager.gb.font_02.render("continue", True, pygame.Color('white'))
    text_04_x = tools.calculate_x_for_game_field_text(text_04_surface)
    text_04_y = text_03_y + 45
    gb.blinking_text_04 = BlinkingText(text_04_surface, text_04_x, text_04_y)


def reset():
    gb.blinking_text_01.reset()
    gb.blinking_text_02.reset()
    gb.blinking_text_03.reset()
    gb.blinking_text_04.reset()


def handle_gametick():
    draw()


def draw():

    if gb.blinking_text_01.toggle:
        tools.draw_rectangle_with_border_and_fill(gb.text_01_x - 48, gb.text_01_y - 10, 200, 200, pygame.Color('black'), 2, pygame.Color('red'))

    gb.blinking_text_01.handle_gametick()
    gb.blinking_text_02.handle_gametick()
    gb.blinking_text_03.handle_gametick()
    gb.blinking_text_04.handle_gametick()


# Dit is de enige 'state' die geen eigen 'handle_input' heeft.
# De reden hiervoor is dat deze state [actief] gemaakt wordt met 'Esc',
# maar dat deze state ook [gestopt] moet kunnen worden met 'Esc'.

# Want; je klikt op 'Esc' als je de game wilt pauzeren en
# je klikt nogmaals op 'Esc' als je weer verder wilt spelen.

# Deze 'Esc' wordt afgevangen in controller_play_screen.handle_input
