import pygame

import blockmania_controller
from blockmania_data import EnumUserInput
from util import font_manager, tools
from util.classes.class_BlinkingText import BlinkingText
from util.classes.class_Delay import Delay
from util.classes.class_RepetitionChecker import RepetitionChecker

repetitionChecker = RepetitionChecker()
delay = Delay(1000 * 10)


class gb:  # global data.

    blinking_text_01: BlinkingText = None

    text_01_x = 0
    text_01_y = 0


def init():
    text_01_surface = font_manager.gb.font_02.render("game over", True, pygame.Color('yellow'))
    gb.text_01_x = tools.calculate_x_for_game_field_text(text_01_surface)
    gb.text_01_y = 185
    gb.blinking_text_01 = BlinkingText(text_01_surface, gb.text_01_x, gb.text_01_y)


def reset():
    delay.reset()
    gb.blinking_text_01.reset()


def handle_gametick(user_input: EnumUserInput, is_input_repeating: bool):

    handle_input(user_input, is_input_repeating)
    draw()

    if delay.has_expired():
        switch_to_title_screen()


def handle_input(user_input: EnumUserInput, is_input_repeating):

    if user_input == EnumUserInput.ESCAPE and not is_input_repeating:
        switch_to_title_screen()


def switch_to_title_screen():
    blockmania_controller.switch_to_title_screen()


def draw():

    if gb.blinking_text_01.toggle:
        tools.draw_rectangle_with_border_and_fill(gb.text_01_x - 45, gb.text_01_y - 20, 280, 90, pygame.Color('black'), 2, pygame.Color('red'))

    gb.blinking_text_01.handle_gametick()
