import pygame

import blockmania_controller
import blockmania_data
import blockmania_display
from general_states.screen_01_title import screen_title
from general_states.screen_02_play import state_01_regular
from general_states.screen_03_preferences import screen_preferences
from general_states.screen_04_help import screen_help
from util.classes.class_Delay import Delay

TRANSITION_STEP_MIN = 0
TRANSITION_STEP_MAX = 12


class gb:  # global data.

    transition_step = TRANSITION_STEP_MIN
    transition_delay = Delay(75)


def trigger_part_one():

    draw_transition_blinds()

    if gb.transition_delay.has_expired():
        gb.transition_step += 1

    if gb.transition_step == TRANSITION_STEP_MAX:
        screen_title.gb.state = screen_title.EnumScreenState.NORMAL
        blockmania_controller.switch_to_play_screen()


def trigger_part_two():

    draw_transition_blinds()

    if gb.transition_delay.has_expired():
        gb.transition_step -= 1

    if gb.transition_step < TRANSITION_STEP_MIN:
        state_01_regular.gb.state = state_01_regular.EnumScreenState.NORMAL
        screen_preferences.gb.state = screen_preferences.EnumScreenState.NORMAL
        screen_help.gb.state = screen_help.EnumScreenState.NORMAL


def calculate_height():

    BLINDS_SIZE_MINIMUM = 5
    return (gb.transition_step * BLINDS_SIZE_MINIMUM)


def draw_transition_blinds():

    BLINDS_COUNT = 13
    BLINDS_SIZE_MAXIMUM = 60

    height = calculate_height()

    for row in range(0, BLINDS_COUNT):

        x = 0
        y = row * BLINDS_SIZE_MAXIMUM

        pygame.draw.rect(blockmania_display.canvas, blockmania_data.COLOR_TRANSITION_BLINDS,
                         pygame.Rect(x, y, blockmania_data.WINDOW_SIZE[0], height))
