import pygame
from pygame.surface import Surface
from enum import Enum

import blockmania_controller
import blockmania_data
import blockmania_display
from general_states.screen_02_play import transition, block_speed
from util import font_manager, tools
from util.classes.class_RadioButton import RadioButton
from util.classes.class_RepetitionChecker import RepetitionChecker

repetitionChecker = RepetitionChecker()


class EnumScreenState(Enum):
    NORMAL     = 10
    TRANSITION = 20


class gb:  # global data.

    state: EnumScreenState = EnumScreenState.NORMAL

    text_02_surface: Surface
    text_02_x = 0
    text_02_y = 0

    text_03_surface: Surface
    text_03_x = 0
    text_03_y = 0

    text_04_surface: Surface
    text_04_x = 0
    text_04_y = 0

    text_05_surface: Surface
    text_05_x = 0
    text_05_y = 0

    text_06_surface: Surface
    text_06_x = 0,
    text_06_y = 0

    text_07_surface: Surface
    text_07_x = 0
    text_07_y = 0

    text_08_surface: Surface
    text_08_x = 0
    text_08_y = 0

    text_09_surface: Surface
    text_09_x = 0
    text_09_y = 0

    text_10_surface: Surface
    text_10_x = 0
    text_10_y = 0

    text_11_surface: Surface
    text_11_x = 0
    text_11_y = 0

    radiobutton_01 = None
    radiobutton_02 = None

    setting_do_level_up = True  # When False, BlockMania will stay put on its current level.
    setting_add_extra_blocks = False


def init():

    gb.text_02_surface = font_manager.gb.font_04.render("-- Preferences --", True, pygame.Color('yellow'))
    gb.text_02_x = tools.calculate_x_for_text(gb.text_02_surface)
    gb.text_02_y = 20

    gb.text_03_surface = font_manager.gb.font_04.render("Play : F1", True, pygame.Color('orange'))
    gb.text_03_x = tools.calculate_x_for_text(gb.text_03_surface)
    gb.text_03_y = blockmania_data.WINDOW_SIZE[1] - 140

    gb.text_04_surface = font_manager.gb.font_04.render("Home : F2", True, pygame.Color('orange'))
    gb.text_04_x = tools.calculate_x_for_text(gb.text_04_surface)
    gb.text_04_y = gb.text_03_y + 40

    gb.text_05_surface = font_manager.gb.font_04.render("How to play : F3", True, pygame.Color('orange'))
    gb.text_05_x = tools.calculate_x_for_text(gb.text_05_surface)
    gb.text_05_y = gb.text_04_y + 40

    # ---

    gb.text_06_surface = font_manager.gb.font_04.render("LEVEL :", True, pygame.Color('white'))
    gb.text_06_x = 175
    gb.text_06_y = gb.text_02_y + 110

    gb.text_07_surface = font_manager.gb.font_02.render(str(block_speed.gb.level), True, pygame.Color('Yellow'))
    gb.text_07_x = gb.text_06_x + gb.text_06_surface.get_width() + 20
    gb.text_07_y = gb.text_06_y - 5

    gb.text_08_surface = font_manager.gb.font_04.render("+ : F5", True, pygame.Color('white'))
    gb.text_08_x = gb.text_07_x + 70
    gb.text_08_y = gb.text_07_y - 20

    gb.text_09_surface = font_manager.gb.font_04.render("- : F6", True, pygame.Color('white'))
    gb.text_09_x = gb.text_08_x
    gb.text_09_y = gb.text_07_y + 25

    # ---

    gb.text_10_surface = font_manager.gb.font_04.render("GRADUALLY INCREASE LEVEL : F7", True, pygame.Color('white'))
    gb.text_10_x = gb.text_06_x - 105
    gb.text_10_y = gb.text_06_y + 110
    gb.radiobutton_01 = RadioButton(gb.text_10_surface, gb.text_10_x, gb.text_10_y, True)

    gb.text_11_surface = font_manager.gb.font_04.render("ADD SOME EXTRA BLOCKS : F8", True, pygame.Color('white'))
    gb.text_11_x = gb.text_10_x
    gb.text_11_y = gb.text_10_y + 90
    gb.radiobutton_02 = RadioButton(gb.text_11_surface, gb.text_11_x, gb.text_11_y, False)



def handle_gametick():

    draw()

    match gb.state:
        case EnumScreenState.NORMAL     : handle_input()
        case EnumScreenState.TRANSITION : transition.trigger_part_one()


def handle_input():

    if repetitionChecker.is_not_repeating(blockmania_controller.gb.user_input):

        match blockmania_controller.gb.user_input:

            case blockmania_data.EnumUserInput.PLAY_SCREEN  : gb.state = EnumScreenState.TRANSITION

            case blockmania_data.EnumUserInput.F5  : increase_level_manually()
            case blockmania_data.EnumUserInput.F6  : decrease_level_manually()

            case blockmania_data.EnumUserInput.F7  : toggle_gradually_increase_level()
            case blockmania_data.EnumUserInput.F8  : toggle_add_weird_blocks()


def increase_level_manually():
    block_speed.increase_level()
    gb.text_07_surface = font_manager.gb.font_02.render(str(block_speed.gb.level), True, pygame.Color('Yellow'))


def decrease_level_manually():
    block_speed.decrease_level()
    gb.text_07_surface = font_manager.gb.font_02.render(str(block_speed.gb.level), True, pygame.Color('Yellow'))

def toggle_gradually_increase_level():
    gb.setting_do_level_up = not gb.setting_do_level_up
    gb.radiobutton_01.set_selected(gb.setting_do_level_up)


def toggle_add_weird_blocks():
    gb.setting_add_extra_blocks = not gb.setting_add_extra_blocks
    gb.radiobutton_02.set_selected(gb.setting_add_extra_blocks)


def draw():

    blockmania_display.canvas.blit(gb.text_02_surface, (gb.text_02_x, gb.text_02_y))
    blockmania_display.canvas.blit(gb.text_03_surface, (gb.text_03_x, gb.text_03_y))
    blockmania_display.canvas.blit(gb.text_04_surface, (gb.text_04_x, gb.text_04_y))
    blockmania_display.canvas.blit(gb.text_05_surface, (gb.text_05_x, gb.text_05_y))
    blockmania_display.canvas.blit(gb.text_06_surface, (gb.text_06_x, gb.text_06_y))
    blockmania_display.canvas.blit(gb.text_07_surface, (gb.text_07_x, gb.text_07_y))
    blockmania_display.canvas.blit(gb.text_08_surface, (gb.text_08_x, gb.text_08_y))
    blockmania_display.canvas.blit(gb.text_09_surface, (gb.text_09_x, gb.text_09_y))

    gb.radiobutton_01.handle_gametick()
    gb.radiobutton_02.handle_gametick()
