import pygame
from pygame.surface import Surface
from enum import Enum

import blockmania_controller
import blockmania_data
import blockmania_display
from general_states.screen_02_play import transition
from util import font_manager, tools
from util.classes.class_RepetitionChecker import RepetitionChecker

repetitionChecker = RepetitionChecker()


class EnumScreenState(Enum):
    NORMAL     = 10
    TRANSITION = 20


class gb:  # global data.

    state: EnumScreenState = EnumScreenState.NORMAL

    text_02_surface: Surface
    text_02_x = 0
    text_02_y = 0

    text_03_surface: Surface
    text_03_x = 0
    text_03_y = 0

    text_04_surface: Surface
    text_04_x = 0
    text_04_y = 0

    text_05_surface: Surface
    text_05_x = 0
    text_05_y = 0

    text_06_surface: Surface
    text_06_x = 0,
    text_06_y = 0

    text_07_surface: Surface
    text_07_x = 0
    text_07_y = 0

    text_09_surface: Surface
    text_09_x = 0
    text_09_y = 0

    text_10_surface: Surface
    text_10_x = 0
    text_10_y = 0

    text_11_surface: Surface
    text_11_x = 0
    text_11_y = 0

    text_13_surface: Surface
    text_13_x = 0
    text_13_y = 0

    text_15_surface: Surface
    text_15_x = 0
    text_15_y = 0


def init():

    gb.text_02_surface = font_manager.gb.font_04.render("-- How to play --", True, pygame.Color('yellow'))
    gb.text_02_x = tools.calculate_x_for_text(gb.text_02_surface)
    gb.text_02_y = 20

    gb.text_03_surface = font_manager.gb.font_04.render("Play : F1", True, pygame.Color('orange'))
    gb.text_03_x = tools.calculate_x_for_text(gb.text_03_surface)
    gb.text_03_y = blockmania_data.WINDOW_SIZE[1] - 140

    gb.text_04_surface = font_manager.gb.font_04.render("Home : F2", True, pygame.Color('orange'))
    gb.text_04_x = tools.calculate_x_for_text(gb.text_04_surface)
    gb.text_04_y = gb.text_03_y + 40

    gb.text_05_surface = font_manager.gb.font_04.render("Preferences : F4", True, pygame.Color('orange'))
    gb.text_05_x = tools.calculate_x_for_text(gb.text_05_surface)
    gb.text_05_y = gb.text_04_y + 40

    gb.text_06_surface = font_manager.gb.font_04.render("Move the block :", True, pygame.Color('red'))
    gb.text_06_x = tools.calculate_x_for_text(gb.text_06_surface)
    gb.text_06_y = gb.text_02_y + 80

    gb.text_07_surface = font_manager.gb.font_04.render("'A', 'S' and 'D' or arrow-keys", True, pygame.Color('white'))
    gb.text_07_x = tools.calculate_x_for_text(gb.text_07_surface)
    gb.text_07_y = gb.text_06_y + 40

    gb.text_09_surface = font_manager.gb.font_04.render("Rotate the block :", True, pygame.Color('red'))
    gb.text_09_x = tools.calculate_x_for_text(gb.text_09_surface)
    gb.text_09_y = gb.text_07_y + 70

    gb.text_10_surface = font_manager.gb.font_04.render("'W' or arrow-UP", True, pygame.Color('white'))
    gb.text_10_x = tools.calculate_x_for_text(gb.text_10_surface)
    gb.text_10_y = gb.text_09_y + 40

    gb.text_13_surface = font_manager.gb.font_04.render("Flip the block : 'spacebar'", True, pygame.Color('white'))
    gb.text_13_x = tools.calculate_x_for_text(gb.text_13_surface)
    gb.text_13_y = gb.text_10_y + 70

    gb.text_15_surface = font_manager.gb.font_04.render("Select block : 'T'", True, pygame.Color('white'))
    gb.text_15_x = tools.calculate_x_for_text(gb.text_15_surface)
    gb.text_15_y = gb.text_13_y + 60

    gb.text_11_surface = font_manager.gb.font_04.render("Pause : 'Esc'", True, pygame.Color('white'))
    gb.text_11_x = tools.calculate_x_for_text(gb.text_11_surface)
    gb.text_11_y = gb.text_15_y + 60


def handle_gametick():

    draw()

    match gb.state:
        case EnumScreenState.NORMAL     : handle_input()
        case EnumScreenState.TRANSITION : transition.trigger_part_one()


def handle_input():

    if blockmania_controller.gb.user_input == blockmania_data.EnumUserInput.NONE:
        return

    if repetitionChecker.is_repeating(blockmania_controller.gb.user_input):
        return

    if blockmania_controller.gb.user_input == blockmania_data.EnumUserInput.PLAY_SCREEN:
        gb.state = EnumScreenState.TRANSITION

def draw():

    blockmania_display.canvas.blit(gb.text_02_surface, (gb.text_02_x, gb.text_02_y))
    blockmania_display.canvas.blit(gb.text_03_surface, (gb.text_03_x, gb.text_03_y))
    blockmania_display.canvas.blit(gb.text_04_surface, (gb.text_04_x, gb.text_04_y))
    blockmania_display.canvas.blit(gb.text_05_surface, (gb.text_05_x, gb.text_05_y))
    blockmania_display.canvas.blit(gb.text_06_surface, (gb.text_06_x, gb.text_06_y))
    blockmania_display.canvas.blit(gb.text_07_surface, (gb.text_07_x, gb.text_07_y))
    blockmania_display.canvas.blit(gb.text_09_surface, (gb.text_09_x, gb.text_09_y))
    blockmania_display.canvas.blit(gb.text_10_surface, (gb.text_10_x, gb.text_10_y))
    blockmania_display.canvas.blit(gb.text_11_surface, (gb.text_11_x, gb.text_11_y))
    blockmania_display.canvas.blit(gb.text_13_surface, (gb.text_13_x, gb.text_13_y))
    blockmania_display.canvas.blit(gb.text_15_surface, (gb.text_15_x, gb.text_15_y))
