from src.util.block_tools import tile_tool, size_tool, matrix_tool, offset_tool
from util.classes.class_Block import Block


class gb:  # global data.
    index = 0


def create_block(block_number) -> Block:
    gb.index = block_number
    return create(block_number)


def create_random_block() -> Block:
    random_block_number = matrix_tool.get_random_block_number()
    gb.index = random_block_number
    return create_block(random_block_number)



def create_next_block() -> Block:
    gb.index += 1
    if gb.index >= matrix_tool.get_block_pool_size():
        gb.index = 0
    return create_block(gb.index)


def create(block_number) -> Block:

    block = Block(block_number)

    matrix_tool.set_matrix(block)

    tile_tool.refresh_tiles(block)
    size_tool.set_size(block)

    offset_tool.calculate_initial_row_offset(block)
    # offset_tool.set_initial_col_offset(block)  Doe dit pas als het block verplaatst wordt naar het field.
    tile_tool.refresh_tiles(block)

    return block
