import pygame
from util import tools


class gb:  # global data.
    tile_colors = []


base_colors = [

    # # Color set 01 :
    # [255, 255, 255],
    # [165, 239, 162],
    # [166, 215, 217],
    # [173, 186, 222],
    # [166, 154, 220],
    # [158, 192, 233],
    # [241, 166, 206],
    # [255, 153, 153]

    # Color set 02 :
    # [255, 255, 255],
    # [111, 137, 123],
    # [144, 160, 142],
    # [177, 185, 165],
    # [217, 209, 189],
    # [191, 171, 155],
    # [177, 153, 144],
    # [255, 153, 153]

    # Color set 03 :
    # [255, 255, 255],
    # [143, 188, 143],
    # [100, 149, 237],
    # [218, 165, 32],
    # [170, 125, 210],
    # [215, 127, 162],
    # [213, 155, 123],
    # [255, 127, 80]

    [255, 255, 255],
    [143, 188, 143],
    [100, 149, 237],
    [218, 165, 32],
    [170, 125, 210],
    [215, 127, 162],
    [213, 155, 123],
    [255, 127, 80],
    [143, 188, 143],
    [100, 149, 237],
    [218, 165, 32],
    [170, 125, 210],
    [215, 127, 162],
    [213, 155, 123],
    [143, 188, 143],
    [100, 149, 237],
    [218, 165, 32],
    [170, 125, 210],
    [215, 127, 162],
    [213, 155, 123]

]


# Calculating tints :
# For tints, calculate (255 - previous value), multiply that by 1/4, 1/2, 3/4, etc,
# (the greater the factor, the lighter the tint), and add that to the previous value,
# (assuming each component is an 8-bit integer).

# Calculating shades :
# For shades, multiply each component by 1/4, 1/2, 3/4, etc, of its previous value.
# The smaller the factor, the darker the shade.


def init():
    gb.tile_colors = tools.create_2d_array(len(base_colors), 3)
    calculate_tints_and_shades()


def calculate_tints_and_shades():

    color_count = len(base_colors)
    for row in range(color_count):

        r = base_colors[row][0]
        g = base_colors[row][1]
        b = base_colors[row][2]

        gb.tile_colors[row][0] = calculate_tint(r, g, b)
        gb.tile_colors[row][1] = pygame.Color(r, g, b)
        gb.tile_colors[row][2] = calculate_shade(r, g, b)


def calculate_tint(r, g, b) -> pygame.Color:

    rt = int(r + ( (255 - r) * 0.25) )
    gt = int(g + ( (255 - g) * 0.25) )
    bt = int(b + ( (255 - b) * 0.25) )

    return pygame.Color(rt, gt, bt)


def calculate_shade(r, g, b) -> pygame.Color:

    rs = int(r * 0.75)
    gs = int(g * 0.75)
    bs = int(b * 0.75)

    return pygame.Color(rs, gs, bs)
