import blockmania_data

# Calculates the size of a Block, measured in Tile and in pixels.

def set_size(block):
    set_block_size_in_tiles(block)
    set_preview_block_size_in_pixels(block)


def set_block_size_in_tiles(block):

    row_min = block.tiles[0].row
    col_min = block.tiles[0].col

    row_max = 0
    col_max = 0

    for tile in block.tiles:

        if tile.row < row_min:
            row_min = tile.row

        if tile.col < col_min:
            col_min = tile.col

        if tile.row > row_max:
            row_max = tile.row

        if tile.col > col_max:
            col_max = tile.col

    block.height_in_tiles = (row_max - row_min) + 1
    block.width_in_tiles  = (col_max - col_min) + 1


def set_preview_block_size_in_pixels(block):

    block.height_in_pixels = (block.height_in_tiles * blockmania_data.PREVIEW_TILE_HEIGHT)
    block.width_in_pixels  = (block.width_in_tiles  * blockmania_data.PREVIEW_TILE_WIDTH)
