from pygame.surface import Surface

import blockmania_display
from util.classes.class_Delay import Delay


class BlinkingText:

    def __init__(self, surface: Surface, x, y):
        self.x = x
        self.y = y

        self._delay = Delay(1000)
        self.toggle = False

        self._surface = surface

    def reset(self):
        self._delay.reset()
        self.toggle = True

    def handle_gametick(self):
        self._draw_text()
        if self._delay.has_expired():
            self.toggle = not self.toggle

    def _draw_text(self):
        if self.toggle:
            blockmania_display.canvas.blit(self._surface, (self.x, self.y))
