from util.classes.class_Offset import Offset
from util.classes.class_Tile import Tile


class Block:
    """
    This is the block on the gamefield that is controlled by the player.
    """

    def __init__(self, number):

        self.number = number
        self.color_code = number + 1

        self.matrix = []

        self.tiles: list[Tile] = []
        self.offset = Offset()

        self.height_in_tiles = 0
        self.width_in_tiles  = 0

        self.height_in_pixels = 0
        self.width_in_pixels  = 0

    def increment_row_offset(self):
        self.offset.row += 1

    def increment_col_offset(self):
        self.offset.col += 1

    def decrement_row_offset(self):
        self.offset.row -= 1

    def decrement_col_offset(self):
        self.offset.col -= 1
