import pygame


class Delay:

    def __init__(self, milliseconds_to_pause):
        self._startTime = 0
        self._millisecondsToPause = milliseconds_to_pause
        self.reset()


    def set_milliseconds_to_pause(self, milliseconds_to_pause):
        self._millisecondsToPause = milliseconds_to_pause


    def has_expired(self) -> bool:
        elapsed_time = pygame.time.get_ticks() - self._startTime
        if elapsed_time >= self._millisecondsToPause:
            self.reset()
            return True
        else:
            return False

    def reset(self):
        self._startTime = pygame.time.get_ticks()
