import pygame
from pygame.surface import Surface

import blockmania_display
from util import tools


class RadioButton:

    def __init__(self, surface: Surface, x, y, is_selected):

        self.x = x
        self.y = y

        self.surface = surface
        self.is_selected = is_selected


    def set_selected(self, is_selected):
        self.is_selected = is_selected


    def handle_gametick(self):
        self._draw_text()


    def _draw_text(self):

        blockmania_display.canvas.blit(self.surface, (self.x + 40, self.y))

        tools.draw_rectangle_with_border_and_fill(self.x, self.y, 30, 30, pygame.Color('black'), 2, pygame.Color('red'))

        if self.is_selected:

            pygame.draw.line(
                blockmania_display.canvas, pygame.Color('white'),
                (self.x + 5, self.y + 5),
                (self.x + 25, self.y + 25), 6
            )

            pygame.draw.line(
                blockmania_display.canvas, pygame.Color('white'),
                (self.x + 5,  self.y + 25),
                (self.x + 25, self.y + 5), 6
            )
