import math

import blockmania_data
from util import tools
from util.block_tools import block_tool
from util.classes.class_Block import Block


class gb:  # global data.
    block: Block = None
    offset_left = 0
    offset_top  = 0


def get_block():
    return gb.block


def set_random_block():
    set_block(block_tool.create_random_block())


def set_block_by_number(number):
    set_block(block_tool.create_block(number))


def set_next_block():
    set_block(block_tool.create_next_block())


def set_block(block):

    gb.block = block
    gb.offset_left = math.trunc((blockmania_data.PREVIEW_FIELD_WIDTH  - gb.block.width_in_pixels)  / 2)
    gb.offset_top  = math.trunc((blockmania_data.PREVIEW_FIELD_HEIGHT - gb.block.height_in_pixels) / 2)


def render():
    draw_preview_field()
    draw_preview_block()


def draw_preview_field():

    tools.draw_rectangle_with_border_and_fill(
        blockmania_data.PREVIEW_FIELD_LOCATION_X, blockmania_data.PREVIEW_FIELD_LOCATION_Y,
        blockmania_data.PREVIEW_FIELD_WIDTH, blockmania_data.PREVIEW_FIELD_HEIGHT,
        blockmania_data.GAME_FIELD_BACKGROUND_COLOR,
        blockmania_data.GAME_FIELD_BORDER_WIDTH, blockmania_data.GAME_FIELD_BORDER_COLOR)


def draw_preview_block():
    for tile in gb.block.tiles:
        draw_tile(tile)


def draw_tile(tile):

    x = (tile.col * blockmania_data.PREVIEW_TILE_WIDTH)  + blockmania_data.PREVIEW_FIELD_LOCATION_X + gb.offset_left
    y = (tile.row * blockmania_data.PREVIEW_TILE_HEIGHT) + blockmania_data.PREVIEW_FIELD_LOCATION_Y + gb.offset_top

    width  = blockmania_data.PREVIEW_TILE_WIDTH
    height = blockmania_data.PREVIEW_TILE_HEIGHT

    tools.draw_tile(x, y, width, height, gb.block.color_code)

